from enum import Enum


class CommunicationProtocolIDs(Enum):
    # INFO
    DEVICE_INFO_BASE = 0
    DEVICE_SN = DEVICE_INFO_BASE + 0
    DEVICE_NAME = DEVICE_INFO_BASE + 1
    DEVICE_VERSION = DEVICE_INFO_BASE + 2
    DEVICE_WITH_RAIL = DEVICE_INFO_BASE + 3
    DEVICE_TIME = DEVICE_INFO_BASE + 4
    DEVICE_ID = DEVICE_INFO_BASE + 5

    # POSE
    DEVICE_POSE_BASE = 10
    GET_POSE = DEVICE_POSE_BASE + 0
    RESET_POSE = DEVICE_POSE_BASE + 1
    GET_KINEMATICS = DEVICE_POSE_BASE + 2
    GET_POSE_L = DEVICE_POSE_BASE + 3

    # ALARM
    ALARM_BASE = 20
    ALARM_STATE = ALARM_BASE + 0

    # HOME
    HOME_BASE = 30
    HOME_PARAMS = HOME_BASE + 0
    HOME_CMD = HOME_BASE + 1
    AUTO_LEVELING = HOME_BASE + 2

    # HHT
    HHT_BASE = 40
    SET_GET_HHTTRIG_MODE = HHT_BASE + 0
    SET_GET_HHTTRIG_OUTPUT_ENABLED = HHT_BASE + 1
    GET_HHTTRIG_OUTPUT = HHT_BASE + 2

    # ARM ORiENTATION
    ARM_ORIENTATION_BASE = 50
    ARM_ORIENTATION = ARM_ORIENTATION_BASE + 0
    
    # END EFFECTOR
    END_EFFECTOR_BASE = 60
    END_EFFECTOR_PARAMS = END_EFFECTOR_BASE + 0
    END_EFFECTOR_LASER = END_EFFECTOR_BASE + 1
    END_EFFECTOR_SUCTION_CUP = END_EFFECTOR_BASE + 2
    END_EFFECTOR_GRIPPER = END_EFFECTOR_BASE + 3

    # JOG
    JOG_BASE = 70
    JOG_JOINT_PARAMS = JOG_BASE + 0
    JOG_COORDINATE_PARAMS = JOG_BASE + 1
    JOG_COMMON_PARAMS = JOG_BASE + 2
    JOG_CMD = JOG_BASE + 3
    JOGL_PARAMS = JOG_BASE + 4

    # PTP
    PTP_BASE = 80
    PTP_JOINT_PARAMS = PTP_BASE + 0
    PTP_COORDINATE_PARAMS = PTP_BASE + 1
    PTP_JUMP_PARAMS = PTP_BASE + 2
    PTP_COMMON_PARAMS = PTP_BASE + 3
    PTP_CMD = PTP_BASE + 4

    PTPL_PARAMS = PTP_BASE + 5
    PTP_WITH_L_CMD = PTP_BASE + 6
    PTP_JUMP_TO_PARAMS = PTP_BASE + 7

    PTPPO_CMD = PTP_BASE + 8
    PTPPO_WITH_L_CMD = PTP_BASE + 9

    # CP
    CP_BASE = 90
    CP_PARAMS = CP_BASE + 0
    CP_CMD = CP_BASE + 1
    CPLE_CMD = CP_BASE + 2

    # ARC
    ARC_BASE = 100
    ARC_PARAMS = ARC_BASE + 0
    ARC_CMD = ARC_BASE + 1

    # WAIT
    WAIT_BASE = 110
    WAIT_CMD = WAIT_BASE + 0

    # TRIG
    TRIG_BASE = 120
    TRIG_CMD = TRIG_BASE + 0

    # EIO
    EIO_BASE = 130
    IO_MULTIPLEXING = EIO_BASE + 0
    IODO = EIO_BASE + 1
    IO_PWM = EIO_BASE + 2
    IODI = EIO_BASE + 3
    IO_ADC = EIO_BASE + 4
    EMOTOR = EIO_BASE + 5
    EMOTORS = EIO_BASE + 6
    COLOR_SENSOR = EIO_BASE + 7
    IR_SWITCH = EIO_BASE + 8

    # CAL
    CAL_BASE = 140
    ANGLE_SENSOR_STATIC_ERROR = CAL_BASE + 0
    ANGLE_SENSOR_COEF = CAL_BASE + 1
    BASE_DECODER_STATIC_ERROR = CAL_BASE + 2
    RHAND_CALIBRATE_VALUE = CAL_BASE + 3

    # WIFI
    WIFI_BASE = 150
    WIFI_CONFIG_MODE = WIFI_BASE + 0
    WIFI_SSID = WIFI_BASE + 1
    WIFI_PASSWORD = WIFI_BASE + 2
    WIFI_IP_ADDRESS = WIFI_BASE + 3
    WIFI_NETMASK = WIFI_BASE + 4
    WIFI_GATEWAY = WIFI_BASE + 5
    WIFI_DNS = WIFI_BASE + 6
    WIFI_CONNECT_STATUS = WIFI_BASE + 7

    # LOST STEP
    LOST_STEP_BASE = 170
    SET_LOST_STEP_PARAMS = LOST_STEP_BASE + 0
    SET_LOST_STEP_CMD = LOST_STEP_BASE + 1
    
    # CHECK MODELCONTENT
    CHECK_MODEL_BASE = 180
    CHECK_MODEL = CHECK_MODEL_BASE + 1

    # PULSE MODE
    PULSE_MODE_BASE = 190
    PULSE_MODE = PULSE_MODE_BASE + 1

    # TEST MODE
    TEST_BASE = 220
    TEST_USER_PARAMS = TEST_BASE + 0
    TEST_PTP_TIME = TEST_BASE + 1

    # QUEUED CMD
    QUEUED_CMD_BASE = 240
    QUEUED_CMD_START_EXEC = QUEUED_CMD_BASE + 0
    QUEUED_CMD_STOP_EXEC = QUEUED_CMD_BASE + 1
    QUEUED_CMD_FORCE_STOP_EXEC = QUEUED_CMD_BASE + 2
    QUEUED_CMD_START_DOWNLOAD = QUEUED_CMD_BASE + 3
    QUEUED_CMD_STOP_DOWNLOAD = QUEUED_CMD_BASE + 4
    QUEUED_CMD_CLEAR = QUEUED_CMD_BASE + 5
    QUEUED_CMD_CURRENT_INDEX = QUEUED_CMD_BASE + 6
    QUEUED_CMD_LEFT_SPACE = QUEUED_CMD_BASE + 7
    QUEUED_CMD_FINISH = QUEUED_CMD_BASE + 8
